// Written by TeTeT

ttt_debug = true;

ttt_bases = [Base_1, Base_2, Base_3, Base_4, Base_5, Base_6, Base_7, Base_8, Base_9];
ttt_lurkers = [];
ttt_villages = [Village_1, Village_2, Village_3, Village_4, Village_5, Village_6, Village_7];
ttt_roads = [Road_1, Road_2, Road_3, Road_4];
ttt_callsigns = ["blue", "red", "yellow", "orange", "black", "brown", "purple", "pink", "white", "black", "green"];
ttt_spawnPoints = [ SpawnNorth, SpawnWest, SpawnSouth, SpawnEast ];
ttt_VCAA = [];
ttt_howitzers = [];
ttt_recoilless = [];

Uns_Radio_enabled = false;

ttt_fnc_createPassengers = {
	params ["_pos", "_heli"];
	private _crewCount = count (crew _heli);
	private _allSeats = count (fullCrew [_heli, "", true]);
	private _openSeats = _allSeats - _crewCount;
	private _grp = createGroup west;

	if (_openSeats < 4) then {
		_grp = [_pos] call ttt_fnc_createOfficer;
	} else {
		if (_openSeats < 10) then {
			private _create = selectRandom [ttt_fnc_createOfficer, ttt_fnc_createTeam, ttt_fnc_createTeam, ttt_fnc_createTeam, ttt_fnc_createTeam];
			_grp = [_pos] call _create;
		} else {
			private _create = selectRandom [ttt_fnc_createTeam, ttt_fnc_createSquad, ttt_fnc_createSquad, ttt_fnc_createSquad, ttt_fnc_createSquad];
			_grp = [_pos] call _create;
		};
	};
	_grp;
};

ttt_fnc_createOfficer = {
	params ["_pos"];
	_pos = _pos getPos [20, random 360];
	private _grp = createGroup west;
	"uns_men_RAR_65_COM" createUnit [_pos, _grp];
	private _callsign = [] call ttt_fnc_getCallSign;
	_grp setGroupId [_callsign];
	_grp;
};

ttt_fnc_createTeam = {
	params ["_pos"];
	_pos = _pos getPos [20, random 360];
	private _grp = createGroup west;
	"uns_men_RAR_65_SL" createUnit [_pos, _grp];
	"uns_men_RAR_65_RTO" createUnit [_pos, _grp];
	"uns_men_RAR_65_RF1" createUnit [_pos, _grp];
	"uns_men_RAR_65_RF2" createUnit [_pos, _grp];
	private _callsign = [] call ttt_fnc_getCallSign;
	_grp setGroupId [_callsign];
	_grp;
};

ttt_fnc_createCrew = {
	params ["_pos"];
	_pos = _pos getPos [20, random 360];
	private _grp = createGroup west;
	"uns_men_RAR_65_ENG" createUnit [_pos, _grp];
	"uns_men_RAR_65_ENG" createUnit [_pos, _grp];
	private _callsign = [] call ttt_fnc_getCallSign;
	_grp setGroupId [_callsign];
	_grp;
};

ttt_fnc_createDownedCrew = {
	params ["_pos", "_members"];
	_pos = _pos getPos [20, random 360];
	private _grp = createGroup west;
	{
		_x createUnit [_pos, _grp];
	} forEach _members;
/*	"uns_pilot3" createUnit [_pos, _grp];
	"uns_pilot4" createUnit [_pos, _grp];
*/	private _callsign = [] call ttt_fnc_getCallSign;
	_grp setGroupId [_callsign];
	_grp;
};

ttt_fnc_createSquad = {
	params ["_pos"];
	_pos = _pos getPos [20, random 360];
	private _grp = createGroup west;
	"uns_men_RAR_65_SL" createUnit [_pos, _grp];
	"uns_men_RAR_65_RTO" createUnit [_pos, _grp];
	"uns_men_RAR_65_RF1" createUnit [_pos, _grp];
	"uns_men_RAR_65_RF2" createUnit [_pos, _grp];
	"uns_men_RAR_65_RF3" createUnit [_pos, _grp];
	"uns_men_RAR_65_RF4" createUnit [_pos, _grp];
	"uns_men_RAR_65_RF5" createUnit [_pos, _grp];
	"uns_men_RAR_65_RF6" createUnit [_pos, _grp];
	"uns_men_RAR_65_MED" createUnit [_pos, _grp];
	"uns_men_RAR_65_GL" createUnit [_pos, _grp];
	private _callsign = [] call ttt_fnc_getCallSign;
	_grp setGroupId [_callsign];
	_grp;
};

ttt_fnc_VCPatrol = {
	params ["_pos"];
	_pos = _pos getPos [20, random 360];
	private _grp = createGroup east;
	"uns_men_VC_mainforce_nco" createUnit [_pos, _grp];
	"uns_men_VC_mainforce_HMG" createUnit [_pos, _grp];
	"uns_men_VC_mainforce_RTO" createUnit [_pos, _grp];
	"uns_men_VC_mainforce_LMG" createUnit [_pos, _grp];
	"uns_men_VC_mainforce_RF1" createUnit [_pos, _grp];
	"uns_men_VC_mainforce_RF2" createUnit [_pos, _grp];
	"uns_men_VC_mainforce_RF3" createUnit [_pos, _grp];
	"uns_men_VC_mainforce_RF4" createUnit [_pos, _grp];
	private _callsign = format ["VC-%1", [] call ttt_fnc_getCallSign];
	_grp setGroupId [_callsign];
	_grp;
};

ttt_fnc_assaultLZ = {
	params ["_pos", "_heli"];

	waitUntil {sleep 0.1; _heli distance _pos < 1500};

	private _spawn = _pos getPos [300, random 360];
	private _squad = [_spawn] call ttt_fnc_VCPatrol;
	private _wp = _squad addWaypoint [_pos, 10];
	_wp setWaypointType "SAD";
	_squad setCombatMode "RED";
	_squad;
};

ttt_fnc_board = {
	params ["_grp", "_heli"];

	{_x assignAsCargo _heli} forEach units _grp;
	private _wp = _grp addWaypoint [(getPos _heli), 5];
	_wp setWaypointType "GETIN";
	waitUntil {{alive _x} count (units _grp) == {_x in _heli} count (units _grp)};
	(leader _grp) sideChat "All aboard";
	_grp;
};

ttt_fnc_disembark = {
	params ["_grp", "_heli"];
    {unassignVehicle _x} forEach units _grp;
    private _wp = _grp addWaypoint [(getPos _heli),15];
    _wp setWaypointType "GETOUT";
	 waitUntil {{alive _x} count (units _grp) == {!(_x in _heli)} count (units _grp)};
	(leader _grp) sideChat "Bye";
	[_grp, getPos (leader _grp), 1000] call BIS_fnc_taskPatrol;
	_grp;
};


ttt_fnc_getCallSign = {
	private _nr = floor random 100;
	private _base = selectRandom ttt_callsigns;

	format ["%1-%2", _base, _nr];
};

ttt_fnc_dispatchLZTeam = {
	params ["_pos", "_heli"];

	private _grp = createGroup west;
	"uns_men_sas_tgr_NCO" createUnit [_pos, _grp];
	"uns_men_sas_tgr_RF1" createUnit [_pos, _grp];
	private _callsign = [] call ttt_fnc_getCallSign;
	_grp setGroupId [_callsign];

	waitUntil {sleep 0.1; _pos distance _heli < 1000};

	if (alive leader _grp) then {
		(leader _grp) sideChat "Dropping smoke and shooting flare";

		private _smoke = "SmokeShellPurple" createVehicle _pos;
		_smoke setPos [_pos select 0, _pos select 1, 50];
		_smoke setDamage 1;
		private _flare = "F_20mm_Red" createVehicle [_pos select 0, _pos select 1, 100];
		sleep 5;
		_flare setVelocity [0, 0, -1];
	};
	true;
};

ttt_fnc_getRandomPos = {
	params ["_centerObject"];

	private _min = 2000;
	private _max = 5000;

	private _pos = [getPos _centerObject, _min, _max, 20, 0, 1, 0] call BIS_fnc_findSafePos;

	// need to find a position not too far away
	while {_pos distance Center > 10000} do {
		_pos = [getPos _centerObject, _min, _max, 20, 0, 1, 0] call BIS_fnc_findSafePos;
	};

	_pos;
};

ttt_fnc_baseLZ = {
	params ["_heli"];
	private _orig = selectRandom ttt_bases;
	private _destPos = [_orig] call ttt_fnc_getRandomPos;
	private _dest = "Land_HelipadEmpty_F" createVehicle _destPos;

	_heli vehicleChat format ["Fly to %1", _orig getVariable "name"];
	private _origMarker = createMarkerLocal ["orig", getPos _orig];
	_origMarker setMarkerTypeLocal "hd_pickup";
	_origMarker setMarkerColorLocal "ColorWhite";
	// Exception for base5, hill950
	private _pos = getPos _orig;
	if (!isNull(_orig getVariable ["spawn", ObjNull])) then {
		_pos = getPos (_orig getVariable "spawn");
	};
	private _grp = [_pos, _heli] call ttt_fnc_createPassengers;
	waitUntil {sleep 1; _heli distance _orig < 20 and speed _heli < 10 and isTouchingGround _heli};
	_heli vehicleChat "Wait for boarding ...";
	[_grp, _heli] call ttt_fnc_board;
	sleep 1;
	deleteMarkerLocal "orig";

	_heli vehicleChat "Fly to LZ marked on map";
	private _lzMarker = createMarkerLocal ["LZ", _destPos];
	_lzMarker setMarkerTypeLocal "hd_objective";
	_lzMarker setMarkerColorLocal "ColorWhite";
	[_destPos, _heli] spawn ttt_fnc_dispatchLZTeam;
	waitUntil {sleep 1; _heli distance _dest < 50 and speed _heli < 10 and isTouchingGround _heli};
	_heli vehicleChat "Unloading ...";
	[_grp, _heli] call ttt_fnc_disembark;
	sleep 1;
	_heli vehicleChat "Task completed";
	deleteMarkerLocal "LZ";
	_heli;
};

ttt_fnc_baseHotLZ = {
	params ["_heli"];
	private _orig = selectRandom ttt_bases;
	private _destPos = [_orig] call ttt_fnc_getRandomPos;
	private _dest = "Land_HelipadEmpty_F" createVehicle _destPos;

	_heli vehicleChat format ["Fly to %1", _orig getVariable "name"];
	private _origMarker = createMarkerLocal ["orig", getPos _orig];
	_origMarker setMarkerTypeLocal "hd_pickup";
	_origMarker setMarkerColorLocal "ColorWhite";
	// Exception for base5, hill950
	private _pos = getPos _orig;
	if (!isNull(_orig getVariable ["spawn", ObjNull])) then {
		_pos = getPos (_orig getVariable "spawn");
	};
	private _grp = [_pos, _heli] call ttt_fnc_createPassengers;
	waitUntil {sleep 1; _heli distance _orig < 20 and speed _heli < 10 and isTouchingGround _heli};
	_heli vehicleChat "Wait for boarding ...";
	[_grp, _heli] call ttt_fnc_board;
	sleep 1;
	deleteMarkerLocal "orig";

	_heli vehicleChat "Fly to LZ marked on map";
	private _lzMarker = createMarkerLocal ["LZ", _destPos];
	_lzMarker setMarkerTypeLocal "hd_objective";
	_lzMarker setMarkerColorLocal "ColorWhite";
	[_destPos, _heli] spawn ttt_fnc_dispatchLZTeam;
	[_destPos, _heli] spawn ttt_fnc_assaultLZ;
	waitUntil {sleep 1; _heli distance _dest < 50 and speed _heli < 10 and isTouchingGround _heli};
	_heli vehicleChat "Unloading ...";
	[_grp, _heli] call ttt_fnc_disembark;
	sleep 1;
	_heli vehicleChat "Task completed";
	deleteMarkerLocal "LZ";
	_heli;
};

ttt_fnc_baseBase = {
	params ["_heli"];
	private _orig = selectRandom ttt_bases;
	private _destBases = ttt_bases - [ _orig ];
	private _dest = selectRandom _destBases;

	_heli vehicleChat format ["Fly to %1", _orig getVariable "name"];
	private _origMarker = createMarkerLocal ["orig", getPos _orig];
	_origMarker setMarkerTypeLocal "hd_pickup";
	_origMarker setMarkerColorLocal "ColorWhite";
	// Exception for base5, hill950
	private _pos = getPos _orig;
	if (!isNull(_orig getVariable ["spawn", ObjNull])) then {
		_pos = getPos (_orig getVariable "spawn");
	};
	private _grp = [_pos, _heli] call ttt_fnc_createPassengers;
	waitUntil {sleep 1; _heli distance _orig < 20 and speed _heli < 10 and isTouchingGround _heli};
	_heli vehicleChat "Wait for boarding ...";
	[_grp, _heli] call ttt_fnc_board;
	sleep 1;
	deleteMarkerLocal "orig";

	_heli vehicleChat format ["Fly to %1", _dest getVariable "name"];
	private _lzMarker = createMarkerLocal ["LZ", getPos _dest];
	_lzMarker setMarkerTypeLocal "hd_objective";
	_lzMarker setMarkerColorLocal "ColorWhite";
	waitUntil {sleep 1; _heli distance _dest < 20 and speed _heli < 10 and isTouchingGround _heli};
	_heli vehicleChat "Unloading ...";
	[_grp, _heli] call ttt_fnc_disembark;
	sleep 1;
	_heli vehicleChat "Task completed";
	deleteMarkerLocal "LZ";
	_heli;
};

ttt_fnc_baseVillage = {
	params ["_heli"];
	private _orig = selectRandom ttt_bases;
	private _dest = selectRandom ttt_villages;
	private _destPos = getPos _dest;

	_heli vehicleChat format ["Fly to %1", _orig getVariable "name"];
	private _origMarker = createMarkerLocal ["orig", getPos _orig];
	_origMarker setMarkerTypeLocal "hd_pickup";
	_origMarker setMarkerColorLocal "ColorWhite";
	// Exception for base5, hill950
	private _pos = getPos _orig;
	if (!isNull(_orig getVariable ["spawn", ObjNull])) then {
		_pos = getPos (_orig getVariable "spawn");
	};
	private _grp = [_pos, _heli] call ttt_fnc_createPassengers;
	waitUntil {sleep 1; _heli distance _orig < 20 and speed _heli < 10 and isTouchingGround _heli};
	_heli vehicleChat "Wait for boarding ...";
	[_grp, _heli] call ttt_fnc_board;
	sleep 1;
	deleteMarkerLocal "orig";

	_heli vehicleChat format ["Fly to %1", _dest getVariable "name"];
	private _lzMarker = createMarkerLocal ["LZ", _destPos];
	_lzMarker setMarkerTypeLocal "hd_objective";
	_lzMarker setMarkerColorLocal "ColorWhite";
	[_destPos, _heli] spawn ttt_fnc_dispatchLZTeam;
	waitUntil {sleep 1; _heli distance _dest < 50 and speed _heli < 10 and isTouchingGround _heli};
	_heli vehicleChat "Unloading ...";
	[_grp, _heli] call ttt_fnc_disembark;
	sleep 1;
	_heli vehicleChat "Task completed";
	deleteMarkerLocal "LZ";
	_heli;
};

ttt_fnc_getRandomRoadLZPos = {
	params ["_centerObject"];

	private _min = 2000;
	private _max = 5000;

	private _pos = [getPos _centerObject, _min, _max, 20, 0, 1, 0] call BIS_fnc_findSafePos;

	// shortcut to initialize it so the check in the loop is done first
	private _farFromRoad = true;
	// need to find a position not too far away
	while {_pos distance Center > 10000 or _farFromRoad} do {
		_pos = [getPos _centerObject, _min, _max, 20, 0, 1, 0] call BIS_fnc_findSafePos;
		private _roads = _pos nearRoads 50;
		if (count _roads > 0) then {
			_farFromRoad = false;
			// _pos = getPos (_roads select 0);
		};
	};

	_pos;
};

ttt_fnc_streetBase = {
	params ["_heli"];
	private _dest = selectRandom ttt_bases;
	private _destPos = getPos _dest;
	private _origPos = [_dest] call ttt_fnc_getRandomRoadLZPos;
	private _type = selectRandom ["uns_willys", "uns_willysmg50", "uns_M35A2", "uns_M35A2_Open", "uns_m37b1", "uns_m37b1_m1919"];
	private _orig = _type createVehicle _origPos;
	_orig setFuel 0;
	_orig setDamage 0.5;

	_heli vehicleChat format ["Fly to stranded vehicle, see map marker"];
	private _origMarker = createMarkerLocal ["orig", getPos _orig];
	_origMarker setMarkerTypeLocal "hd_pickup";
	_origMarker setMarkerColorLocal "ColorWhite";
	private _grp = [getPos _orig, _heli] call ttt_fnc_createCrew;

	waitUntil {sleep 0.1; _heli distance _orig < 1000};
	if (alive leader _grp) then {
		(leader _grp) sideChat "Dropping smoke and shooting flare";

		private _smoke = "SmokeShellPurple" createVehicle _origPos;
		_smoke setPos [_origPos select 0, _origPos select 1, 50];
		_smoke setDamage 1;
		private _flare = "F_20mm_Red" createVehicle [_origPos select 0, _origPos select 1, 100];
		sleep 5;
		_flare setVelocity [0, 0, -1];
	};
	waitUntil {sleep 1; _heli distance _orig < 100 and speed _heli < 10 and isTouchingGround _heli};
	_heli vehicleChat "Wait for boarding ...";
	[_grp, _heli] call ttt_fnc_board;
	sleep 1;
	deleteMarkerLocal "orig";

	_heli vehicleChat format ["Fly to %1", _dest getVariable "name"];
	private _lzMarker = createMarkerLocal ["LZ", _destPos];
	_lzMarker setMarkerTypeLocal "hd_objective";
	_lzMarker setMarkerColorLocal "ColorWhite";
	waitUntil {sleep 1; _heli distance _dest < 20 and speed _heli < 10 and isTouchingGround _heli};
	_heli vehicleChat "Unloading ...";
	[_grp, _heli] call ttt_fnc_disembark;
	sleep 1;
	_heli vehicleChat "Task completed";
	deleteMarkerLocal "LZ";
	_heli;
};

ttt_fnc_baseStreet = {
	systemChat "No written yet";
};

// Based on script by [GR]GEORGE F
ttt_fnc_crashBase = {
	params ["_heli"];

	private _dest = selectRandom ttt_bases;
	private _destPos = getPos _dest;
	private _origPos = [_dest] call ttt_fnc_getRandomPos;
	private _orig = "Land_HelipadEmpty_F" createVehicle _origPos;
	private _crashSite = _origPos getPos [50, random 360];

	private _wreckInfo = selectRandom [
		["uns_E2A_Wreck", ["uns_pilN1", "uns_pilN1", "uns_pilN1", "uns_pilN1"]],
		["uns_a1j_Wreck", ["uns_pil2"]],
		["uns_a3b_Wreck", ["uns_pilN1", "uns_pilN1", "uns_pilN1"]],
		["uns_A4_Wreck", ["uns_pilN1"]],
		["uns_A6_Wreck", ["uns_pilN1", "uns_pilN1"]],
		["uns_A7_wreck", ["uns_pilN1"]],
		["uns_ah1g_Wreck", ["uns_pilot16"]],
		["uns_c1a_wreck", ["uns_pilN1", "uns_pilN1"]],
		["uns_ch47_wreck", ["uns_pilot3", "uns_pilot4"]],
		["uns_f100_Wreck", ["uns_pil2"]],
		["UNS_F111_wreck", ["uns_pil1", "uns_pil1"]],
		["uns_h21c_wreck", ["uns_pilot3", "uns_pilot4"]],
		["uns_oh6_wreck", ["uns_pilot3", "uns_pilot4"]],
		["uns_uh1c_wreck", ["uns_pilot3", "uns_pilot4"]],
		["uns_uh1d_wreck", ["uns_pilot3", "uns_pilot4"]],
		["uns_uh1_Wreck", ["uns_pilot3", "uns_pilot4"]],
		["uns_uh1h_wreck", ["uns_pilot3", "uns_pilot4"]]
	];

	private _wreck = _wreckInfo select 0;
	private _wreckObj = createVehicle [_wreck, _crashSite, [], 0, "CAN_COLLIDE"];

	//https://community.bistudio.com/wiki/setParticleClass
	_particle1 = "#particlesource" createVehicleLocal _crashSite;
	_particle1 setParticleClass "MediumSmoke";
	_particle1 attachTo [_crashsite,[0,0,0]];

	//https://community.bistudio.com/wiki/setParticleFire
	//source setParticleFire [coreIntensity, coreDistance, damageTime]
	_particle2 = "#particlesource" createVehicleLocal _crashsite;
	_particle2 setParticleClass "BigDestructionSmoke";
	_particle2 setParticleFire [0.3,1.0,0.1];
	//MediumSmoke	//ObjectDestructionSmoke	//ObjectDestructionFire1Smallx
	//SmallDestructionSmoke	SmallDestructionFire MediumDestructionFire MediumDestructionSmoke BigDestructionFire BigDestructionSmoke

	//Create a Crater	(Crater , CraterLong , CraterLong_small)
	createVehicle ["CraterLong", _crashsite, [], 0, "CAN_COLLIDE"];

	_heli vehicleChat format ["Fly to crash site, see map marker"];
	private _origMarker = createMarkerLocal ["orig", getPos _orig];
	_origMarker setMarkerTypeLocal "hd_pickup";
	_origMarker setMarkerColorLocal "ColorWhite";
	private _grp = [getPos _orig, _wreckInfo select 1] call ttt_fnc_createDownedCrew;
	[_origPos, _heli] spawn ttt_fnc_dispatchLZTeam;
	waitUntil {sleep 1; _heli distance _orig < 100 and speed _heli < 10 and isTouchingGround _heli};
	_heli vehicleChat "Wait for boarding ...";
	[_grp, _heli] call ttt_fnc_board;
	sleep 1;
	deleteMarkerLocal "orig";

	_heli vehicleChat format ["Fly to %1", _dest getVariable "name"];
	private _lzMarker = createMarkerLocal ["LZ", _destPos];
	_lzMarker setMarkerTypeLocal "hd_objective";
	_lzMarker setMarkerColorLocal "ColorWhite";
	waitUntil {sleep 1; _heli distance _dest < 20 and speed _heli < 10 and isTouchingGround _heli};
	_heli vehicleChat "Unloading ...";
	[_grp, _heli] call ttt_fnc_disembark;
	sleep 1;
	_heli vehicleChat "Task completed";
	deleteMarkerLocal "LZ";
	_heli;

};

ttt_fnc_LZBase = {
	params ["_heli"];

	private _dest = selectRandom ttt_bases;
	private _destPos = getPos _dest;
	private _origPos = [_dest] call ttt_fnc_getRandomPos;
	private _orig = "Land_HelipadEmpty_F" createVehicle _origPos;

	_heli vehicleChat format ["Fly to LZ, see map marker"];
	private _origMarker = createMarkerLocal ["orig", getPos _orig];
	_origMarker setMarkerTypeLocal "hd_pickup";
	_origMarker setMarkerColorLocal "ColorWhite";
	private _grp = [getPos _orig, _heli] call ttt_fnc_createPassengers;
	[_grp, _heli] spawn {
		params ["_grp", "_heli"];
		private _pos = getPos leader _grp;
		waitUntil {sleep 0.1; _pos distance _heli < 1000};

		(leader _grp) sideChat "Dropping smoke";

		private _smoke = "SmokeShellPurple" createVehicle _pos;
		_smoke setPos [_pos select 0, _pos select 1, 5];
		_smoke setDamage 1;
		_smoke;
	};
	waitUntil {sleep 1; _heli distance _orig < 100 and speed _heli < 10 and isTouchingGround _heli};
	_heli vehicleChat "Wait for boarding ...";
	[_grp, _heli] call ttt_fnc_board;
	sleep 1;
	deleteMarkerLocal "orig";

	_heli vehicleChat format ["Fly to %1", _dest getVariable "name"];
	private _lzMarker = createMarkerLocal ["LZ", _destPos];
	_lzMarker setMarkerTypeLocal "hd_objective";
	_lzMarker setMarkerColorLocal "ColorWhite";
	waitUntil {sleep 1; _heli distance _dest < 20 and speed _heli < 10 and isTouchingGround _heli};
	_heli vehicleChat "Unloading ...";
	[_grp, _heli] call ttt_fnc_disembark;
	sleep 1;
	_heli vehicleChat "Task completed";
	deleteMarkerLocal "LZ";
	_heli;
};


/**
[] spawn {

	waitUntil {alive player};
	sleep 1;

	private _heli = vehicle player;

	while {true} do {
		private _pos = [_heli] call ttt_getRandomPos;

		systemChat str _pos;

		sleep 5;

		private _lzMarker = createMarkerLocal ["LZ", _pos];
		_lzMarker setMarkerTypeLocal "hd_objective";

		hint "Fly to marker";

		waitUntil {_heli distance getMarkerPos _lzMarker < 10 and speed _heli < 10};
		deleteMarkerLocal "LZ";
		systemChat "LZ complete, getting next";
		sleep 1;
	};

};
**/

ttt_fnc_initBase = {
	params ["_base"];
	// spawn some patrols and other people at the camps
	// private _patrol = [getPos _base] call ttt_fnc_createTeam; // ttt_fnc_createSquad;
	// [_patrol, getPos _base, 100] call BIS_fnc_taskPatrol;
	// _patrol = [getPos _base] call ttt_fnc_createTeam; // ttt_fnc_createSquad;
	// [_patrol, getPos _base, 100] call BIS_fnc_taskPatrol;

	[_base getPos [50, getDir _base + random 180]] call ttt_fnc_createTeamAgents;
	[_base getPos [50, getDir _base - random 180]] call ttt_fnc_createTeamAgents;
	_base;
};


ttt_fnc_createTeamAgents = {
	params ["_pos"]	;
	{
		private _agent = createAgent [_x, _pos, [], 5, "NONE"];
		// found in http://killzonekid.com/arma-scripting-tutorials-agents-how-to/
		_agent disableAI "FSM";
		_agent setBehaviour "CARELESS";
		[_agent, selectRandom ["STAND1", "KNEEL", "LISTEN_BRIEFING", "GUARD"], "ASIS"] call BIS_fnc_ambientAnim;
	} forEach ["uns_men_USMC_65_SL", "uns_men_USMC_65_RTO", "uns_men_USMC_65_RF1", "uns_men_USMC_65_RF2"];

};



ttt_fnc_initLurker = {
	params ["_pos"];
	[_pos] call ttt_fnc_createTeamAgents;
	// private _lurkers = [_pos] call ttt_fnc_createTeam; // ttt_fnc_createSquad;
	// private _wp = _lurkers addWaypoint [leader _lurkers, 5];
	// _wp setWaypointType "DISMISS";
	// _wp setWaypointFormation "Diamond";
};


// add some sleep for smoother init phase
ttt_fnc_initBases = {
	{
		[_x] call ttt_fnc_initBase;
		sleep 1;
	} forEach ttt_bases;
	{
		[_x] call ttt_fnc_initLurker;
		sleep 1;
	} forEach ttt_lurkers;
	{
		createVehicleCrew _x;
		sleep 1;
	} forEach ttt_recoilless;
	{
		if (selectRandom [true, false, false, false]) then {
			private _pos = _x buildingPos 1;
			private _clazz = selectRandom [
				"uns_men_RAR_65_RF1", "uns_men_RAR_65_RF2", "uns_men_RAR_65_RF3", "uns_men_RAR_65_RF4", "uns_men_RAR_65_RF5", "uns_men_RAR_65_RF6"
			];
			private _men = _clazz createVehicle _pos;
			_men setPos _pos;
			_men setDir (getDir _x);
		};
	} forEach (center nearObjects ["LAND_tower_1", 10000]);
	{
		private _pos = getPos _x;
		private _arty = "Uns_M114_artillery" createVehicle _pos;
		_arty setDir (getDir _x);
		sleep 0.1;
		_arty setDamage 0;
	} forEach (center nearObjects ["LAND_CSJ_gunpit", 10000]);
};

ttt_fnc_planeTraffic = {
	params ["_spawn"];

	private _type = selectRandom [ "uns_A1J_CAS", "uns_A4E_skyhawk_CAS", "UNS_skymaster_CAS", "uns_F4J_CAS" ];
	private _plane = createVehicle [_type, _spawn, [], 500, "FLY"];
	createVehicleCrew _plane;
	{
		private _wp = (group driver _plane) addWaypoint [_x, 1000];
		_wp setWaypointType "MOVE";
	} forEach (ttt_bases call BIS_fnc_arrayShuffle);
	private _wp = (group driver _plane) addWaypoint [_spawn, 1000];
	_wp setWaypointType "CYCLE";
	_plane;
};

ttt_fnc_heloTraffic = {
	params ["_spawn"];
	private _type = selectRandom [ "uns_UH1D_m60", "uns_UH1D_m60", "uns_ch34_USMC", "uns_H13_medevac_USMC", "uns_H13_amphib_USMC", "uns_ch53_base", "uns_oh6_transport" ];
	private _helo = createVehicle [_type, _spawn, [], 100, "FLY"];
	createVehicleCrew _helo;
	{
		private _wp = (group driver _helo) addWaypoint [_x, 0];
		_wp setWaypointType "MOVE";
		private _pos = [_x] call ttt_fnc_getRandomPos;
		_wp = (group driver _helo) addWaypoint [_pos, 0];
		_wp setWaypointType "MOVE";
	} forEach (ttt_bases call BIS_fnc_arrayShuffle);
	private _wp = (group driver _helo) addWaypoint [Center, 100];
	_wp setWaypointType "CYCLE";
	_helo;
};

ttt_fnc_refuel = {
	// aircraft are two arrays of planes and helos
	params ["_vehs"];
	while {count _vehs > 0} do {
		sleep 600;
		// Probably needs a check for alive _x as well
		{
			_x setFuel 1;
		} forEach _vehs;
	};
};

// add sleep to prevent crashes...
ttt_fnc_airTraffic = {
	private _planes = [];
	private _helos = [];
	{
		private _plane = [_x] call ttt_fnc_planeTraffic;
		_planes pushBack _plane;
		sleep 2;
	} forEach ttt_spawnPoints; // + ttt_spawnPoints;
	{
		private _helo = [_x] call ttt_fnc_heloTraffic;
		_helos pushBack _helo;
		sleep 5;
	} forEach ttt_bases; // + ttt_villages;
	// {
	// 	private _pos = Center getPos [200 + random 200, random 360];
	// 	private _helo = [_pos] call ttt_fnc_heloTraffic;
	// 	_helos pushBack _helo;
	// 	sleep 5;
	// } forEach [1, 2, 3, 4, 5, 6, 7, 8];

	[_planes + _helos] spawn ttt_fnc_refuel;
	ttt_aircraft = [_planes, _helos];
	publicVariable "ttt_aircraft";
	ttt_aircraft;
};

ttt_fnc_landTraffic = {
	private _vehs = [];
	private _cars = ["uns_willys", "uns_willysmg50", "uns_M35A2", "uns_M35A2_Open", "uns_m37b1", "uns_m37b1_m1919"];
	{
		private _road = _x;
		private _convoy = [];
		private _grp = createGroup west;

		private _veh = createVehicle [selectRandom _cars, getPos _road, [], 0, "NONE"];
		_veh setDir (getDir _road);
		createVehicleCrew _veh;
		_convoy pushBack _veh;
		_vehs pushBack _veh;
		(crew _veh) joinSilent _grp;
		private _basePos = getPos _veh;
		{
			private _pos = _basePos getPos [10 + 10 * _foreachIndex, (getDir _veh) - 180];
			private _veh = createVehicle [selectRandom _cars, _pos, [], 0, "NONE"];
			_veh setDir (getDir _road);
			createVehicleCrew _veh;
			_convoy pushBack _veh;
			_vehs pushBack _veh;
			(crew _veh) joinSilent _grp;
		} forEach [1, 2];

		private _targetRoad = selectRandom (ttt_roads - [ _road ]);
		private _wp = _grp addWaypoint [_targetRoad, 0];
		_wp setWaypointType "MOVE";
		_wp setWaypointSpeed "LIMITED";
		_wp setWaypointFormation "COLUMN";

		private _wp = _grp addWaypoint [_road, 0];
		_wp setWaypointType "MOVE";
		_wp setWaypointSpeed "LIMITED";
		_wp setWaypointFormation "COLUMN";

		private _wp = _grp addWaypoint [_targetRoad, 0];
		_wp setWaypointType "CYCLE";
	} forEach ttt_roads;
	[_vehs] spawn ttt_fnc_refuel;
};


// added sleeps for smoother init phase
ttt_fnc_VCAA = {
	private _type = "uns_dshk_high_VC";
	{
		systemChat format ["Spawning VC AA %1", _x];
		private _pos = _x getPos [100, random 360];
		private _aa = createVehicle [_type, _pos, [], 10, "NONE"];
		createVehicleCrew _aa;
/*		private _mrkr = createMarker [format ["MarkerVCAA%1", _foreachIndex], _pos];
		_mrkr setMarkerText "AA";
		_mrkr setMarkerColor "ColorRed";
		_mrkr setMarkerAlpha 1;
		_mrkr setMarkerType "hd_destroy";
*/
/**
 * No more patrols
		sleep 2;
		if (selectRandom [true, false]) then {
			_pos = _x getPos [500, random 360];
			private _patrol = [_pos] call ttt_fnc_VCPatrol;
			[_patrol, _pos, 1000] call BIS_fnc_taskPatrol;
		};
		sleep 2;
		if (selectRandom [true, false]) then {
			_pos = _x getPos [500, random 360];
			private _patrol = [_pos] call ttt_fnc_VCPatrol;
			[_patrol, _pos, 1000] call BIS_fnc_taskPatrol;
		};
**/		
	} forEach ttt_VCAA;
};


ttt_fnc_opener = {
	waitUntil {sleep 0.1; !isNil "ttt_aircraft"};
	// plane or helo
	private _type = selectRandom [0,1];
	private _obj = selectRandom (ttt_aircraft select _type);
	private _pos = getPos _obj;
	_pos = [_pos select 0, _pos select 1, (_pos select 2) + 200];
	private _cam = "camera" camCreate _pos;
	_cam cameraEffect [ "internal", "back" ];
	_cam camSetFOV 0.7;

	private _i = 0;
	while {_i < 20} do {
		_cam camSetTarget _obj;
		_pos = _obj getPos [-50, getDir _obj];
		_pos = [_pos select 0, _pos select 1, (getPos _obj select 2) + 50];
		_cam camSetPos _pos;
		_cam camCommit 1;
		sleep 1;
		_i = _i + 1;
	};
	_cam cameraEffect [ "terminate", "back" ];
	camDestroy _cam;
	ttt_aircraft;
};

/**
 * Artillery fire for ambiance
 **/
ttt_fnc_artyFire = {
	sleep 1;
};
/**
	{
		{
			createVehicleCrew _x;
		} forEach _x;
		sleep 1;
	} forEach ttt_howitzers;
	sleep 10;
	// fire the howitzers every 60 to 90 seconds
	while {time > 0} do {
		private _battery = selectRandom ttt_howitzers;
		private _leadGun = _battery select 0;
		private _tgt = _leadGun getPos [10000, getDir _leadGun - 10 + random 20];
		{
			[_x, _tgt, "", 200, 10, [30,60]] spawn BIS_fnc_fireSupport;
		} forEach _battery;
		sleep(300 + random 300);
	};
};
**/
ttt_fnc_missions = {
	params [["_unit", ObjNull]];

	if (isNull _unit) exitWith {diag_log "Cannot assign missions to null object";};

	private _tasks = [ ttt_fnc_crashBase, ttt_fnc_streetBase, ttt_fnc_baseLZ, ttt_fnc_baseBase,
	           ttt_fnc_baseVillage, ttt_fnc_LZBase, ttt_fnc_baseHotLZ ];

	_unit setVariable ["missionAllowed", false, true];
	sleep 1;
	Cmdr sideChat "Get out here - pilot a helicopter and go do some flying!";
	sleep 1;
	Cmdr sideChat "Tasking will start once aboard a helicopter in the pilot spot";
	sleep 5;

	waitUntil {sleep 1; vehicle _unit != _unit and (vehicle _unit) isKindOf "helicopter" and _unit == driver (vehicle _unit)};

	(vehicle _unit) vehicleChat "Welcome aboard! Tasking will start soon.";
	sleep 1;
	(vehicle _unit) vehicleChat "Boarding crew";
	createVehicleCrew (vehicle _unit);
	// add Aussie helmet
	{
		removeHeadgear _x;
		_x addHeadgear "uns_hp_helmet_aus";
	} forEach crew (vehicle player);	
	sleep 5;
	// evil side effect on count _tasks to keep it at 5 tasks
	while {count _tasks > 2} do {
		private _task = selectRandom _tasks;
		_tasks = _tasks - [_task];

		[vehicle _unit] call _task;
		sleep 10;
	};
	Cmdr sideChat "All tasks completed, RTB!";
	_unit setVariable ["missionAllowed", true, true];
};


[] spawn {

	private _hc1Present = !(isNil "HC1");

	if (_hc1Present and isMultiplayer) then {
		if (!isServer and !hasInterface) then {
			systemChat "Spawning on HC";
			diag_log "On the HC";
			[] spawn ttt_fnc_initBases;
			[] spawn ttt_fnc_airTraffic;
			[] spawn ttt_fnc_landTraffic;
			[] spawn ttt_fnc_VCAA;
			[] spawn ttt_fnc_artyFire;
		};
	} else {
		if (isServer) then {
			systemChat "Spawning on Server";
			diag_log "On the server";
			[] spawn ttt_fnc_initBases;
			[] spawn ttt_fnc_airTraffic;
			[] spawn ttt_fnc_landTraffic;
			[] spawn ttt_fnc_VCAA;
			[] spawn ttt_fnc_artyFire;
		};
	};

	if (hasInterface) then {
		setViewDistance 4000;

		0 cutText ["Welcome to Vietnam", "BLACK IN", 15, false];
		1 cutText ["Talk to the commander in the hangar to get transport missions", "PLAIN DOWN", 5, false];
		waitUntil {alive player and !isNull player};
/*		 and !(isNil "ttt_aircraft")};
		[] spawn ttt_fnc_opener;
		sleep 20;
*/
		player setVariable ['missionAllowed', true, true];
		Cmdr addAction ["Assign missions", "[player] spawn ttt_fnc_missions", nil, 5, true, true, "", "player getVariable 'missionAllowed'"];
	};

};